﻿class org.moock.tools.EventProxy {
  private var receiverObj:Object;
  private var funcRef:Function;
 
  /** 
   * receiverObj  包含將被呼叫的funcName的物件。
   * funcName     為了回應特定事件而被呼叫的函數名稱。
   */
  function EventProxy(receiverObj:Object, funcRef:Function) {
    this.receiverObj  = receiverObj;
    this.funcRef = funcRef;
  }
 
  /**
   * 在註冊的事件被組件廣播之前呼叫。
   * 將事件呼叫轉交給receiverObj物件的方法。
   */
  private function handleEvent(eventObj:Object):Void {
    // 如果沒有定義函數名稱…
    if (funcRef == undefined) {
      // …把這個呼叫傳給事件名稱方法
      receiverObj[eventObj.type](eventObj);
    } else {
      // …否則，把這個呼叫傳給指定的方法名稱。
      funcRef.call(receiverObj, eventObj);
    }
  }
}
